﻿using System;
using System.Windows.Threading;
using ComApiUsageExampleDexMultiThreading.Services;

namespace ComApiUsageExampleDexMultiThreading
{
    class Program
    {

        [STAThread]
        static void Main(string[] args)
        {

            using (var referenceData = new ReferenceDataService())
            {
                Console.WriteLine("Reference data service initialized");

                Console.WriteLine(referenceData.FieldValue("AAPL.O", "TR.BusinessSummary"));
                Console.WriteLine("");
                Console.WriteLine(referenceData.FieldValue("GOOG.O", "TR.BusinessSummary"));
                Console.WriteLine("");
                Console.WriteLine(referenceData.FieldValue("TRI.N", "TR.BusinessSummary"));
            }

            Console.ReadKey();
        }

        #region DispatcherFrame 

        public static DispatcherFrame frame; //the object is required in order to release the Windows message pump while executing asynchronous calls.

        public static void StopMessagePump()
        {
            frame.Continue = false;
            frame = null;
        }

        public static DispatcherFrame GetDispatcherFrame()
        {
            return frame ?? (frame = new DispatcherFrame());
        }

        #endregion

    }

  

}
